#include<bits/stdc++.h>
using namespace std;
int o,a,b,ab,n,t[10^6];
string pacijenti[10^6];
int zbira, zbirab, zbirb, zbiro;
int o1, a1, b1, ab1;
int main()
{
  zbiro=0;
  zbira=0;
  zbirb=0;
  zbirab=0;

  cin >> n;
  cin >> o >> a >> b >> ab;
  for(int i=0; i<n; i++)
  {
    cin >> pacijenti[i] >> t[i];

    if(pacijenti[i]=="O")
    {
      zbiro=zbiro+t[i];
    }

    if(pacijenti[i]=="A")
    {
      zbira=zbira+t[i];
    }

      if(pacijenti[i]=="B")
    {
      zbirb=zbirb+t[i];
    }

      if(pacijenti[i]=="AB")
    {
      zbirab=zbirab+t[i];
    }
  }
  
  a1=a; b1=b; o1=o; ab1=ab;
  
  if(zbiro>o)
  {
    cout << "nemoguce" << endl;
    return 0;
  }
  o=o-zbiro;


  if(a-zbira<0)
  {
    if((a+o)-zbira<0 )//a je kolko imam zbira kolko treba
    {
      cout << "nemoguce" << endl;
      o=o-a-zbira;
      zbira=zbira-a;
      return 0;
    }
  }
  zbira=zbira-a;



  if(b-zbirb<0)
  {
    if((b+o)-zbirb<0 )//a je kolko imam zbira kolko treba
    {
      cout << "nemoguce" << endl;
      o=o-(b-zbirb);
      zbirb=zbirb-b;
      return 0;
    }
  }
  zbirb=zbirb-b;


  if((ab+a+b+o)-zbirab<0)
  {
    cout << "nemoguce" << endl;
    return 0;
  }
   else
	{
    	cout << "moguce" << endl;                  
	}
											///pacijenti[i] da li je O,A,B,AB
											///t[i] koliko treba da ima krvi, stoji pored pacijenata
											///o,a,b,ab je koliko ima krvi u bolnici
											///n je broj pacijenata
											///zbiro, zbira, zbirb, zbirab koliko treba krvi ukupno, ali ne mora da bude bas tako npr. zbirab moze biti 5, a da je t[i]=4, ali ako ima jedan o,a,b sve jedno ce raditi
											
	for(int i=0; i<=n; i++)
	{
		if (pacijenti[i]=="O")              ///pocetak O
		{
			cout << t[i] <<" 0 0 0" << endl;
			o1=o1-t[i];
		}									///kraj O
		
		if (pacijenti[i]=="A")
		{
			if(a1>=t[i])
			{
				cout << "0 " << t[i] << " 0 0" << endl;
				a1=a1-t[i];
			}
			else
			{
				cout << t[i]-a1;
				cout <<" " << t[i]-(t[i]-a1) << " 0 0" << endl;
				t[i]=t[i]-a1;
			}
		}
		
		
		if (pacijenti[i]=="B")
		{
			if(b1>=t[i])
			{
				cout << "0 0 " << t[i] << " 0" << endl;
				b1=b1-t[i];
			}
			else
			{
				cout << t[i]-b1;
				cout <<" 0 " << t[i]-(t[i]-b1) << " 0 " << endl;
				t[i]=t[i]-b1;
			}
		}
		
		if (pacijenti[i]=="AB")
		{
			
			if(ab1>=t[i])
			{
				cout << "u najboljem ifu je" << endl << endl;
				cout << "0 0 0 " << t[i] << endl;
				t[i]=t[i]-ab1;
			}
			else
			{
				if(o1>=t[i]-ab1)   ///t[i]=4 oq=7-3 =1          
				{
					//cout << ab1 << endl << t[i] << endl <<o1;       ///ab1 ima, t[i] koliko treba, o1 koliko ima O
					cout << t[i]-(t[i]-o1) << " 0 0 "<< t[i]-o1 << endl;
				}
				
				if(a1>=t[i]-ab1)
				{

					cout << "0 " << t[i]-(t[i]-a1) << " 0 "<< t[i]-a1 << endl;
				}
				if(b1>=t[i]-ab1)
				{
					cout << "0 0 " << t[i]-(t[i]-b1)<< " " << t[i]-b1 << endl;
				}
			}
		}
	}
}